/*
 * File:   cluster.cpp
 * Author: mint
 *
 * Created on June 16, 2009, 12:21 PM
 */

#include "cluster.h"

#include <fstream>
#include <fstream>

using namespace std;

extern vector<Locus*> locus;
extern vector<Individual*> persons;
extern int Sn;
extern vector<Results> Un;
extern vector<vector<double> > Uboot;
extern int totalSamples;

void outputResults(ostream &out, Results &R)
{
    out << R.snp->id << " " << R.a1 << " " << R.p << " " << R.odds << " ";

    if(R.UdA1 <= ' ') R.UdA1 = 'X';
    if(R.UeA1 <= ' ') R.UeA1 = 'X';

    out << R.UdA1 << " " << R.UdOR << " ";
    out << R.UeA1 << " " << R.UeOR << "\n";
}

Results readResults(istream &in)
{
    Results R;

    int id;
    in >> id;

    in >> R.a1 >> R.p >> R.odds >> R.UdA1 >> R.UdOR >> R.UeA1 >> R.UeOR;

    R.snp = locus[id];

    return R;
}


void outputL0(ostream &out, vector<vector<Results> > &L0)
{
    out << Sn << "\n";
    out << totalSamples << "\n";

    // output Un
    out << Un.size() << "\n";

    for(int i = 0; i < Un.size(); i++) outputResults(out, Un[i]);

    // output L0
    out << L0.size() << "\n";

    for(int i = 0; i < L0.size(); i++) {
        out << L0[i].size() << "\n";

        for(int j = 0; j < L0[i].size(); j++)
             outputResults(out, L0[i][j]);
    }
}

void readL0(istream &in, vector<vector<Results> > &L0)
{
    in >> Sn;

    int tot;
    in >> tot;
    totalSamples += tot;

    int n;
    // Replace Un

    in >> n;
    Un.resize(0);
    for(int i = 0; i < n; i++) Un.push_back(readResults(in));

    in >> n;

    // Add to L0
    for(int i = 0; i < n; i++) {
        vector<Results> R;

        int size;
        in >> size;

        for(int j = 0; j < size; j++) R.push_back(readResults(in));

        L0.push_back(R);
        //cout << "read " << R[0].snp->name << " " << R[0].UdOR << "\n";
    }
}





void outputL1(ostream &out)
{
    const vector<vector< double > > & U = Uboot;

    // output the 2d matrix uboot

    out << U.size() << "\n";

    for(int i = 0; i < U.size(); i++) {
        out << U[i].size() << "\n";

        for(int j = 0; j < U[i].size(); j++)
            out << U[i][j] << " ";

        out << "\n";
    }
}


void readL1(istream &in)
{
    int n;
    // add to uboot

    in >> n;

    for(int i = 0; i < n; i++) {
        vector<double> R;

        int size;
        in >> size;

        for(int j = 0; j < size; j++) { double v; in >> v; R.push_back(v); }

        Uboot.push_back(R);
    }
}


// Divide iterations evenly and return a appropriate number of iterations for this instance.
int divide(int K, int N, int B)
{
    int t = B / N;

    int remain = B - t * N;

    if ( K <= remain ) t ++;

    return t;
}
